SystemOrganization addCategory: #'JQWidgetBox-HoverIntent-Core'!

!JQueryInstance methodsFor: '*jqwidgetbox-hoverintent-core' stamp: 'JohanBrichau 10/17/2009 08:01'!
hoverIntent
	^ self create: JQHoverIntent			! !

!JQueryInstance methodsFor: '*jqwidgetbox-hoverintent-core' stamp: 'JohanBrichau 11/5/2009 21:24'!
hoverIntent: in onLeave: out
	self call: 'hoverIntent' with: in asFunction with: out asFunction! !

JQPlugin subclass: #JQHoverIntent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-HoverIntent-Core'!

!JQHoverIntent commentStamp: 'JohanBrichau 11/5/2009 10:21' prior: 0!
JQuery wrapper for Hoverintent 

http://cherne.net/brian/resources/jquery.hoverIntent.html!

!JQHoverIntent methodsFor: 'options' stamp: 'JohanBrichau 11/5/2009 11:36'!
interval: aNumber
	"milliseconds of polling interval"
	self optionAt: 'interval' put: aNumber! !

!JQHoverIntent methodsFor: 'accessing' stamp: 'JohanBrichau 10/17/2009 08:02'!
method
	^ 'hoverIntent'! !

!JQHoverIntent methodsFor: 'options' stamp: 'JohanBrichau 11/5/2009 21:53'!
out: aFunction
	"onMouseOut javascript callback (required)"
	self optionAt: 'out' put: aFunction asFunction! !

!JQHoverIntent methodsFor: 'options' stamp: 'JohanBrichau 11/5/2009 21:53'!
over: anObject
	"onMouseOver javascript callback (required)"
	self optionAt: 'over' put: anObject asFunction! !

!JQHoverIntent methodsFor: 'options' stamp: 'JohanBrichau 11/5/2009 11:38'!
sensitivity: aNumber
	"sensitivity threshold (must be 1 or higher)"
	self optionAt: 'sensitivity' put: aNumber! !

!JQHoverIntent methodsFor: 'options' stamp: 'JohanBrichau 11/5/2009 11:38'!
timeout: aNumber
	"milliseconds before mouseOut callback is invoked"
	self optionAt: 'timeout' put: aNumber! !

!JQWidgetBoxDeploymentLibrary methodsFor: '*jqwidgetbox-hoverintent-core' stamp: 'JohanBrichau 11/5/2009 20:37'!
jqueryhoverintentJs
	^ '/**
* hoverIntent r5 // 2007.03.27 // jQuery 1.1.2+
* <http://cherne.net/brian/resources/jquery.hoverIntent.html>
* 
* @param  f  onMouseOver function || An object with configuration options
* @param  g  onMouseOut function  || Nothing (use configuration options object)
* @author    Brian Cherne <brian@cherne.net>
*/
(function($){$.fn.hoverIntent=function(f,g){var cfg={sensitivity:7,interval:100,timeout:0};cfg=$.extend(cfg,g?{over:f,out:g}:f);var cX,cY,pX,pY;var track=function(ev){cX=ev.pageX;cY=ev.pageY;};var compare=function(ev,ob){ob.hoverIntent_t=clearTimeout(ob.hoverIntent_t);if((Math.abs(pX-cX)+Math.abs(pY-cY))<cfg.sensitivity){$(ob).unbind("mousemove",track);ob.hoverIntent_s=1;return cfg.over.apply(ob,[ev]);}else{pX=cX;pY=cY;ob.hoverIntent_t=setTimeout(function(){compare(ev,ob);},cfg.interval);}};var delay=function(ev,ob){ob.hoverIntent_t=clearTimeout(ob.hoverIntent_t);ob.hoverIntent_s=0;return cfg.out.apply(ob,[ev]);};var handleHover=function(e){var p=(e.type=="mouseover"?e.fromElement:e.toElement)||e.relatedTarget;while(p&&p!!=this){try{p=p.parentNode;}catch(e){p=this;}}if(p==this){return false;}var ev=jQuery.extend({},e);var ob=this;if(ob.hoverIntent_t){ob.hoverIntent_t=clearTimeout(ob.hoverIntent_t);}if(e.type=="mouseover"){pX=ev.pageX;pY=ev.pageY;$(ob).bind("mousemove",track);if(ob.hoverIntent_s!!=1){ob.hoverIntent_t=setTimeout(function(){compare(ev,ob);},cfg.interval);}}else{$(ob).unbind("mousemove",track);if(ob.hoverIntent_s==1){ob.hoverIntent_t=setTimeout(function(){delay(ev,ob);},cfg.timeout);}}};return this.mouseover(handleHover).mouseout(handleHover);};})(jQuery);'! !
